# Method: createConferenceWithBots.create

Creates a conference and adds bots.

The video resolution requested by the bots mimics the resolution that would be requested by a Meet client using the "Auto" layout. See <https://support.google.com/meethardware/answer/9295022>.

- if numOfBots == 1: bots will request HD (1280x720) from the active speaker.
- if numOfBots \< 6: bots will request VGA (640x360) from all participants.
- if numOfBots \< 16: bots will request HVGA (480x270) from all participants.
- otherwise: bots will request HQVGA (240x135) from all participants.

### HTTP request

`POST https://botsondemand.googleapis.com/v1/createConferenceWithBots`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "numOfBots": integer, "ttlSecs": integer, "defaultBotOptions": { object (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#BotOptions`) }, "perBotOptions": [ { object (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#BotOptions`) } ] } ``` |

| Fields ||
|---|---|
| `numOfBots` | `integer` Required. The number of bots to add, must be between 1 - 50. |
| `ttlSecs` | `integer` Required. TTL in seconds for the bots to stay in the meeting. |
| `defaultBotOptions` | ``object (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#BotOptions`)`` Optional. Default options for all bots created as part of this request. |
| `perBotOptions[]` | ``object (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#BotOptions`)`` Optional. Per bot options for bots created as part of this request. If fewer options are provided than the number of bots, the default options will be used for the remaining bots. |

### Response body

Response for {@link CreateConferenceWithBotsRequest}

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "conferenceCode": string, "errorMessages": [ string ] } ``` |

| Fields ||
|---|---|
| `conferenceCode` | `string` The created conference. |
| `errorMessages[]` | `string` The error messages returned by the failed bots. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/meetings`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).

## BotOptions

Options specific to individual bots

| JSON representation |
|---|
| ``` { "requestedResolution": enum (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#SupportedVideoResolutions`), "muteAudio": boolean, "muteVideo": boolean, "playbackVideo": enum (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#VideoFile`), "outputResolution": enum (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#SupportedVideoResolutions`) } ``` |

| Fields ||
|---|---|
| `requestedResolution` | ``enum (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#SupportedVideoResolutions`)`` Optional. Incoming resolution requested by the bots. |
| `muteAudio` | `boolean` Optional. Mute audio sent from bot, default False |
| `muteVideo` | `boolean` Optional. Mute video sent from bot, default False |
| `playbackVideo` | ``enum (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#VideoFile`)`` Optional. The video file the bot should play |
| `outputResolution` | ``enum (`https://developers.google.com/bots-on-demand/reference/rest/v1/createConferenceWithBots/create#SupportedVideoResolutions`)`` Optional. Outgoing video resolution sent by the bots, the will select a playback video matching this resolution. This is only used if playbackVideo is not set. |

## SupportedVideoResolutions

Supported video resolutions presets

| Enums ||
|---|---|
| `SUPPORTED_VIDEO_RESOLUTIONS_UNSPECIFIED` | Resolution unspecified |
| `THUMBNAIL_160_120` | Thumbnail resolution |
| `QVGA_320_180` | QVGA resolution at 16:9 ratio |
| `HVGA_480_270` | HVGA resolution at 16:9 ratio |
| `VGA_640_360` | VGA resolution at 16:9 ratio |
| `HD_1280_720` | HD resolution at 16:9 ratio |
| `FHD_1920_1080` | FHD resolution at 16:9 ratio |

## VideoFile

Supported playback videos for external partners

| Enums ||
|---|---|
| `VIDEO_FILE_UNSPECIFIED` | File unspecified |
| `SINGLE_ATTENDEE_IDLE_1` | Single meeting attendee sitting idle |
| `SINGLE_ATTENDEE_CLAPPING_1` | Single meeting attendee clapping |